Index: /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java	(revision 4932)
@@ -534,164 +291,33 @@
 	    subcollection_pane.add(subcollection_list_pane, BorderLayout.CENTER);
 	    subcollection_pane.add(button_pane, BorderLayout.SOUTH);
-	}
-	/** Create the subindex controls.
-	 * @see org.greenstone.gatherer.cdm.SubcollectionManager.Control.AddSubIndexListener
-	 * @see org.greenstone.gatherer.cdm.SubcollectionManager.Control.ClearDefaultListener
-	 * @see org.greenstone.gatherer.cdm.SubcollectionManager.Control.ChangeListener
-	 * @see org.greenstone.gatherer.cdm.SubcollectionManager.Control.RemoveSubIndexListener
-	 * @see org.greenstone.gatherer.cdm.SubcollectionManager.Control.SetDefaultListener
-	 * @see org.greenstone.gatherer.util.ExclusiveListListener
-	 */
-	public void createSubIndex() {
-	    // Creation
-	    JPanel subindex_name_panel = new JPanel();
-	    JLabel subindex_name_label = new JLabel(get("PartitionName"));
-	    subindex_name = new JTextField();
-
-	    add_index = new JButton(get("Add_Subindex"));
-	    add_index.setMnemonic(KeyEvent.VK_A);
-	    add_index.setEnabled(false);
-	    JPanel button_pane_2 = new JPanel();
-	    clear_default = new JButton(get("Clear_Default_Subindex"));
-	    clear_default.setMnemonic(KeyEvent.VK_C);
-	    if(default_index == null) {
-		clear_default.setEnabled(false);
-	    }
-	    JLabel default_label = new JLabel(get("Default_Subindex"));
-	    JPanel default_pane = new JPanel();
-	    if(default_index == null) {
-		default_value = new JTextField();
-	    }
-	    else {
-		default_value = new JTextField(default_index.getSubIndex().toString());
-	    }
-	    default_value.setBackground(Gatherer.config.getColor("coloring.collection_tree_background", false));
-	    default_value.setEditable(false);
-	    JPanel subindex_inner_pane_1 = new JPanel();
-	    JPanel subindex_inner_pane_2 = new JPanel();
-	    remove_index = new JButton(get("Remove_Subindex"));
-	    remove_index.setMnemonic(KeyEvent.VK_R);
-	    set_default = new JButton(get("Set_Default_Subindex"));
-	    set_default.setMnemonic(KeyEvent.VK_S);
-	    JLabel subcollection_label = new JLabel(get("Subcollection"));
-	    subcollection_list_2 = new JList(model);
-	    JPanel list_2_pane = new JPanel();
-	    subindex_pane = new JPanel();
-	    JLabel subindexes_label = new JLabel(get("Subindexes"));
-	    subindexes_list = new JList(subindexes);
-	    subindexes_list.setCellRenderer(new SubIndexListCellRenderer());
-	    subindexes_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
-	    JPanel subindexes_pane = new JPanel();
-
-	    // Add listeners
-	    ExclusiveListSelectionListener ell = new ExclusiveListSelectionListener();
-	    ell.add(subcollection_list_2);
-	    ell.add(subindexes_list);
-	    add_index.addActionListener(new AddSubIndexListener());
-	    clear_default.addActionListener(new ClearDefaultSubIndexListener());
-	    remove_index.addActionListener(new RemoveSubIndexListener());
-	    set_default.addActionListener(new SetDefaultSubIndexListener());
-
-	    subindex_name.getDocument().addDocumentListener(new SubIndexNameDocumentListener());
-	    subcollection_list_2.addListSelectionListener(new SubCollectionList2Listener());
-
-	    // Layout
-	    subindex_name_panel.setLayout(new BorderLayout());
-	    subindex_name_panel.add(subindex_name_label, BorderLayout.WEST);
-	    subindex_name_panel.add(subindex_name, BorderLayout.CENTER);
-
-	    list_2_pane.setLayout(new BorderLayout());
-	    list_2_pane.add(subcollection_label, BorderLayout.NORTH);
-	    list_2_pane.add(new JScrollPane(subcollection_list_2), BorderLayout.CENTER);
-	    
-	    subindexes_pane.setLayout(new BorderLayout());
-	    subindexes_pane.add(subindexes_label, BorderLayout.NORTH);
-	    subindexes_pane.add(new JScrollPane(subindexes_list), BorderLayout.CENTER);
-	    
-	    subindex_inner_pane_2.setLayout(new GridLayout(1,2,0,5));
-	    subindex_inner_pane_2.add(list_2_pane);
-	    subindex_inner_pane_2.add(subindexes_pane);
-	    
-	    default_label.setBorder(BorderFactory.createEmptyBorder(0,0,0,5));
-	    default_pane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(5,5,5,5), BorderFactory.createRaisedBevelBorder()), BorderFactory.createEmptyBorder(2,2,2,2)));
-	    default_pane.setLayout(new BorderLayout());
-	    default_pane.add(default_label, BorderLayout.WEST);
-	    default_pane.add(default_value, BorderLayout.CENTER);
-	    
-	    subindex_inner_pane_1.setLayout(new BorderLayout());
-	    subindex_inner_pane_1.add(subindex_name_panel, BorderLayout.NORTH);
-	    subindex_inner_pane_1.add(subindex_inner_pane_2, BorderLayout.CENTER);
-	    subindex_inner_pane_1.add(default_pane, BorderLayout.SOUTH);
-	    
-	    button_pane_2.setLayout(new GridLayout(2,2));
-	    button_pane_2.add(add_index);
-	    button_pane_2.add(remove_index);
-	    button_pane_2.add(clear_default);
-	    button_pane_2.add(set_default);
-	    
-	    subindex_pane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
-	    subindex_pane.setLayout(new BorderLayout());
-	    subindex_pane.add(subindex_inner_pane_1, BorderLayout.CENTER);
-	    subindex_pane.add(button_pane_2, BorderLayout.SOUTH);
-	}
-	
-	
+
+	    tabbed_pane.addTab(get("Subcollection_Controls"), subcollection_pane);
+	    tabbed_pane.addTab(get("Subindex_Controls"), (JPanel) CollectionDesignManager.subcollectionindex_manager.getControls());
+	    tabbed_pane.addTab(get("Language_Controls"), (JPanel) CollectionDesignManager.language_manager.getControls());
+
+	    border_pane.setBorder(BorderFactory.createEmptyBorder(0,5,5,5));
+	    border_pane.setLayout(new BorderLayout());
+	    border_pane.add(tabbed_pane, BorderLayout.CENTER);
+
+	    setLayout(new BorderLayout());
+	    add(header_pane, BorderLayout.NORTH);
+	    add(border_pane, BorderLayout.CENTER);
+	}
+       	
 	/** Method to unregister any listeners to avoid memory leaks.
 	 */
 	public void destroy() {
 	}
-	/** We have overriden this method to provide completely different functionality, given that our JPanel will never actually have focus. We call this method in GUI on the view we are about to replace, and this method checks if a change has occured and if so updates the current object.
-	 * @return A <i>boolean</i> which is always <i>false</i>.
-	 * @see org.greenstone.gatherer.msm.ElementWrapper
-	 */
-	public boolean hasFocus() {
-	    // If we have a current metadata open, and something has changed then save the change.
-	    if(changed && current != null) {
-		String n = name.getText();
-		String s = null;
-		Object o = source.getSelectedItem();
-		if(o instanceof ElementWrapper) {
-		    ElementWrapper e = (ElementWrapper)o;
-		    s = e.toString();
-		}
-		String e = match.getText();
-		String f = flags.getText();
-		if(n != null && n.length() > 0 && (s == null || s.length() > 0) && e != null && e.length() > 0) {
-		    current.update(n, s, e, include.isSelected(), f);
-		    int index = model.indexOf(current);
-		    changed();
-		    subindexes.changed();
-		    if(default_index != null) {
-			default_value.setText(default_index.getSubIndex().toString());
-		    }
-		}
-		changed = false;
-	    }
-	    return false;
-	}
-	/** Overriden to ensure the instructions are scrolled to top.
-	 */
-	public void updateUI() {
-	    if(instructions != null) {
-		instructions.setCaretPosition(0);
-	    }
-	    super.updateUI();
-	}
-
-	/** Method to validate the current subcollection editor values, and enable or disable controls (add button) based on said values. 
-	 * we want to disable add until a new name is present 
-	 */
-	protected void validateAdd() {
-	    if(changed && name.getText().length() > 0 && match.getText().length() > 0) {
-		if (subcollections.containsKey(name.getText())) {
-		    add.setEnabled(false);
-		} else {
-		    add.setEnabled(true);
-		}
-	    }
-	    else {
-		add.setEnabled(false);
-	    }
-	}
+
+	public void gainFocus() {
+	    // Rebuild the sources combobox
+	    Vector source_model = Gatherer.c_man.getCollection().msm.getAssignedElements();
+	    source_model.add(0, "Filename"); // Add filename as a possible source.
+	    source_combobox.setModel(new DefaultComboBoxModel(source_model));
+	}
+
+	public void loseFocus() {
+	}
+
 	/** Listens for actions apon the 'add' button in the SubcollectionManager controls, and if detected calls the addSubcollection method of the manager with a newly created subcollection. */
 	private class AddSubCollectionListener
@@ -703,48 +329,30 @@
 	     */
 	    public void actionPerformed(ActionEvent event) {
-		String n = name.getText(); // not allowed spaces!
-		if (n.indexOf(' ')!=-1) {
-		    n = n.substring(0, n.indexOf(' '));
-		    name.setText(n);
-		}
-		String s = null;
-		Object o = source.getSelectedItem();
-		if(o instanceof ElementWrapper) {
-		    ElementWrapper e = (ElementWrapper)o;
-		    s = e.toString();
-		}
-		String e = match.getText();
-		String f = flags.getText();
-		if(n != null && n.length() > 0 && (s == null || s.length() > 0) && e != null && e.length() > 0) {
-		    Subcollection sub = new Subcollection(n, include.isSelected(), s, e, f);
-		    addSubcollection(sub);
-		}
-		changed = false;
-		validateAdd();
-	    }
-	}
-	/** Listens for actions apon the 'add subindex' button in the SubcollectionManager controls, and if detected calls the addSubindex method of the manager with a newly created subindex. */
-	private class AddSubIndexListener
-	    implements ActionListener {
-	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a series of subcollections selected, and if so build an new subindex based apon them.
-	     * @param event An <strong>ActionEvent</strong> containing information about the event.
-	     * @see org.greenstone.gatherer.cdm.SubIndex
-	     */
-	    public void actionPerformed(ActionEvent event) {
-		if(!subcollection_list_2.isSelectionEmpty() && subindex_name.getText().length() > 0) {
-		    Vector selected = new Vector();
-		    Object raw[] = subcollection_list_2.getSelectedValues();
-		    for(int i = 0; i < raw.length; i++) {
-			selected.add(raw[i]);
+		String name = name_field.getText();
+		String source = null;
+		Object object = source_combobox.getSelectedItem();
+		if(object instanceof ElementWrapper) {
+		    ElementWrapper element_wrapper = (ElementWrapper)object;
+		    source = element_wrapper.getName();
+		    if(source.indexOf(MSMUtils.NS_SEP) == -1) {
+			source = Utility.EXTRACTED_METADATA_NAMESPACE + MSMUtils.NS_SEP + source;
 		    }
-		    SubIndex subindex = new SubIndex(selected);
-		    addSubIndex(subindex);
-		    // Add the subindexes name.
-		    CollectionMeta metadata = new CollectionMeta(manager, subindex, manager.languages.getDefaultLanguage(), subindex_name.getText());
-		    manager.collectionmetadatum.addMetadata(metadata);
-		}
-	    }
-	}
-	/** This class listens for any key entry in a text field, selection change in a combobox or button click, and when detected sets the changed flag to true. Its also convenient to use this class to test if the add button should be active yet. */
+		}
+		else {
+		    source = object.toString();
+		}
+		String pattern = match_field.getText();
+		String flags = flags_field.getText();
+		if(name.length() > 0 && (source == null || source.length() > 0) && pattern.length() > 0) {
+		    Subcollection subcollection = new Subcollection(name, include_button.isSelected(), source, pattern, flags);
+		    addSubcollection(subcollection);
+		    // Change the selection to the new subcollection
+		    subcollection_list.setSelectedValue(subcollection, true);
+		}
+		add_button.setEnabled(false);
+	    }
+	}
+
+	/** This class listens for any key entry in a text field, selection change in a combobox or button click, and updates a subcollection as appropriate. Its also convenient to use this class to test if the add button should be active yet. */
 	private class SubCollectionChangeListener
 	    implements DocumentListener, ActionListener {
@@ -753,14 +361,12 @@
 	     */
 	    public void actionPerformed(ActionEvent event) {
-		changed = true;
 		validateAdd();
 	    }
 
 	    public void changedUpdate(DocumentEvent event) {
-		changed = true;
 		validateAdd();
 	    }
+
 	    public void insertUpdate(DocumentEvent event) {
-		changed = true;
 		validateAdd();
 
@@ -768,20 +374,22 @@
 
 	    public void removeUpdate(DocumentEvent event) {
-		changed = true;
 		validateAdd();
 	    }
-	}
-	/** Listens for actions apon the 'clear default subindex' button in the SubcollectionManager controls, and if detected calls the setDefaultSubIndex() method of the manager with <i>null</i>. */
-	private class ClearDefaultSubIndexListener
-	    implements ActionListener {
-	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to clear the default subindex.
-	     * @param event An <strong>ActionEvent</strong> containing information about the event.
-	     */
-	    public void actionPerformed(ActionEvent event) {
-		setDefaultSubIndex(null);
-		clear_default.setEnabled(false);
-		default_value.setText("");
-	    }
-	}
+
+	    /** Method to validate the current subcollection editor values, and enable or disable controls (add button) based on said values. */
+	    private void validateAdd() {
+		if(name_field.getText().length() > 0 && match_field.getText().length() > 0) {
+		    if (getSubcollection(name_field.getText()) == null) {
+			add_button.setEnabled(true);
+		    } else {
+			add_button.setEnabled(false);
+		    }
+		}
+		else {
+		    add_button.setEnabled(false);
+		}
+	    }
+	}
+
 	/** Listens for actions apon the 'remove' button in the SubcollectionManager controls, and if detected calls the remove method of the manager with the SubIndex selected for removal. */
 	private class RemoveSubCollectionListener
@@ -793,40 +401,39 @@
 	    public void actionPerformed(ActionEvent event) {
 		if(!subcollection_list.isSelectionEmpty()) {
-		    Subcollection sub_col = (Subcollection)subcollection_list.getSelectedValue();
-		    removeSubIndexes(sub_col);
-		    removeSubcollection(sub_col);
-		}
-	    }
-	}
-	/** Listens for actions apon the 'remove subindex' button in the SubcollectionManager controls, and if detected calls the removeSubIndex method of the manager with the SubIndex selected for removal. */
-	private class RemoveSubIndexListener
+		    Subcollection subcollection = (Subcollection)subcollection_list.getSelectedValue();
+		    removeSubcollection(subcollection);
+		    // And remove subcollection indexes dependant on this subcollection
+		    CollectionDesignManager.subcollectionindex_manager.removeSubcollectionIndexes(subcollection);
+		}
+		remove_button.setEnabled(false);
+	    }
+	}
+
+	private class UpdateSubCollectionListener
 	    implements ActionListener {
-	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a subindex selected, and if so remove it.
-	     * @param event An <strong>ActionEvent</strong> containing information about the event.
-	     * @see org.greenstone.gatherer.cdm.SubIndex
-	     */
 	    public void actionPerformed(ActionEvent event) {
-		if(!subindexes_list.isSelectionEmpty()) {
-		    removeSubIndex((SubIndex)subindexes_list.getSelectedValue());
-		}
-	    }
-	}
-	/** Listens for actions apon the 'set default subindex' button in the SubcollectionManager controls, and if detected calls the setDefaultSubIndex method of the manager with the SubIndex selected for default. */
-	private class SetDefaultSubIndexListener
-	    implements ActionListener {
-	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a subindex selected, and if so set it as default.
-	     * @param event An <strong>ActionEvent</strong> containing information about the event.
-	     * @see org.greenstone.gatherer.cdm.DefaultSubIndex
-	     * @see org.greenstone.gatherer.cdm.SubIndex
-	     */
-	    public void actionPerformed(ActionEvent event) {
-		if(!subindexes_list.isSelectionEmpty()) {
-		    setDefaultSubIndex(new DefaultSubIndex((SubIndex)subindexes_list.getSelectedValue()));
-		    clear_default.setEnabled(true);
-		    default_value.setText(default_index.getSubIndex().toString());
-		}
-	    }
-	}
-
+		if(!subcollection_list.isSelectionEmpty()) {
+		    Subcollection subcollection = (Subcollection)subcollection_list.getSelectedValue();
+		    String name = name_field.getText();
+		    String source = null;
+		    Object object = source_combobox.getSelectedItem();
+		    if(object instanceof ElementWrapper) {
+			ElementWrapper element_wrapper = (ElementWrapper)object;
+			source = element_wrapper.getName();
+			if(source.indexOf(MSMUtils.NS_SEP) == -1) {
+			    source = Utility.EXTRACTED_METADATA_NAMESPACE + MSMUtils.NS_SEP + source;
+			}
+		    }
+		    else {
+			source = object.toString();
+		    }
+		    String pattern = match_field.getText();
+		    String flags = flags_field.getText();
+		    if(name.length() > 0 && (source == null || source.length() > 0) && pattern.length() > 0) {
+			updateSubcollection(subcollection, name, include_button.isSelected(), source, pattern, flags);
+		    }
+		}
+	    }
+	}
 
 	/** This class listens for selections in the list on the subcollections pane of the SubcollectionManager, and updates the controls as necessary to reflect selection. */
@@ -839,123 +446,61 @@
 	     */
 	    public void valueChanged(ListSelectionEvent event) {
-		// If we have a previous collection and the users changed something, but not added, then update subcollection.
-		if(changed && current != null) {
-		    String n = name.getText();
-		    String s = null;
-		    Object o = source.getSelectedItem();
-		    if(o instanceof ElementWrapper) {
-			ElementWrapper e = (ElementWrapper)o;
-			s = e.toString();
-		    }
-		    String e = match.getText();
-		    String f = flags.getText();
-		    if(n != null && n.length() > 0 && (s == null || s.length() > 0) && e != null && e.length() > 0) {
-			current.update(n, s, e, include.isSelected(), f);
-			int index = model.indexOf(current);
-			changed();
-			subindexes.changed();
-			if(default_index != null) {
-			    default_value.setText(default_index.getSubIndex().toString());
-			}
-		    }
-		}
-		// Now load the new entry.
+		// Now the entry
 		if(!subcollection_list.isSelectionEmpty()) {
-		    current = (Subcollection) subcollection_list.getSelectedValue();
-		    flags.setText(current.getFlags());
-		    include.setSelected(current.getInclude());
-		    exclude.setSelected(!current.getInclude());
-		    match.setText(current.getExpression());
-		    name.setText(current.getName());
-		    String s = current.getSource();
+		    Subcollection subcollection = (Subcollection) subcollection_list.getSelectedValue();
+		    flags_field.setText(subcollection.getFlags());
+		    include_button.setSelected(subcollection.isInclusive());
+		    exclude_button.setSelected(!subcollection.isInclusive());
+		    match_field.setText(subcollection.getPattern());
+		    name_field.setText(subcollection.getName());
+		    String s = subcollection.getSource();
 		    int pos = 0;
-		    Object value = source.getItemAt(pos);
+		    Object value = source_combobox.getItemAt(pos);
+		    //ystem.err.println("Search for: " + s);
 		    while(value != null) {
 			if(value instanceof ElementWrapper) {
 			    ElementWrapper e = (ElementWrapper) value;
-			    if(e.toString().equals(s)) {
-				source.setSelectedIndex(pos);
+			    String e_name = e.getName();
+			    if(e_name.indexOf(MSMUtils.NS_SEP) == -1) {
+				e_name = Utility.EXTRACTED_METADATA_NAMESPACE + MSMUtils.NS_SEP + e_name;
+			    }
+			    //ystem.err.print("Compare to: " + e_name);
+			    if(e_name.equals(s)) {
+				source_combobox.setSelectedIndex(pos);
 				value = null;
+				//ystem.err.println(" - Match");
 			    }
 			    else {
 				pos++;
-				value = source.getItemAt(pos);
+				value = source_combobox.getItemAt(pos);
+				//ystem.err.println(" - Fail");
 			    }
 			}
 			else if(value.toString().equals(s)) {
-			    source.setSelectedIndex(pos);
+			    source_combobox.setSelectedIndex(pos);
 			    value = null;
 			}
 			else {
 			    pos++;
-			    value = source.getItemAt(pos);
+			    value = source_combobox.getItemAt(pos);
 			}
 		    }
 		    // Can't add one thats already there.
-		    add.setEnabled(false);
-		    // You can remove it though...
-		    remove.setEnabled(true);
+		    add_button.setEnabled(false);
+		    // You can update or remove it though...
+		    remove_button.setEnabled(true);
+		    update_button.setEnabled(true);
 		}
 		else {
-		    flags.setText("");
-		    include.setSelected(true);
-		    match.setText("");
-		    name.setText("");
-		    source.setSelectedIndex(0);
-		    remove.setEnabled(false);
-		}
-		// Have to do this after so we don't get called when nothings actually changed.
-		changed = false;
-		
-	    }
-	}
-
-	private class SubCollectionList2Listener
-	    implements ListSelectionListener {
-
-	    public void valueChanged(ListSelectionEvent event) {
-		if(!event.getValueIsAdjusting()) {
-		    add_index.setEnabled(!subcollection_list_2.isSelectionEmpty() && subindex_name.getText().length() > 0);
-		}
-	    }
-	}
-	
-	private class SubIndexListCellRenderer
-	    extends DefaultListCellRenderer {
-	    
-	    public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
-		StringBuffer text = new StringBuffer(value.toString());
-		// Retrieve the indexes name if any.
-		CollectionMeta metadata = manager.collectionmetadatum.getMetadata(value, manager.languages.getDefaultLanguage(), true);
-		if(metadata != null) {
-		    text.append(" \"");
-		    text.append(metadata.getValue());
-		    text.append("\"");
-		}
-		return super.getListCellRendererComponent(list, text.toString(), index, isSelected, cellHasFocus);
-	    }
-
-	}
-	
-	private class SubIndexNameDocumentListener
-	    implements DocumentListener {
-	    /** Gives notification that an attribute or set of attributes changed. */
-	    public void changedUpdate(DocumentEvent e) {
-		update();
-	    }
-	    /** Gives notification that there was an insert into the document. */
-	    public void insertUpdate(DocumentEvent e) {
-		update();
-	    }
-	    /** Gives notification that a portion of the document has been removed. */
-	    public void removeUpdate(DocumentEvent e) {
-		update();
-	    }
-	    /** The text area has changed in some way. Given that this can only happed when we are editing or adding a text fragment we better respond appropriately. */
-	    private void update() {
-		add_index.setEnabled(!subcollection_list_2.isSelectionEmpty() && subindex_name.getText().length() > 0);
-	    }
-	}
-
+		    flags_field.setText("");
+		    include_button.setSelected(true);
+		    match_field.setText("");
+		    name_field.setText("");
+		    source_combobox.setSelectedIndex(0);
+		    remove_button.setEnabled(false);
+		    update_button.setEnabled(false);
+		}
+	    }
+	}
     }
 }
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/SuperCollection.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/SuperCollection.java	(revision 4932)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/SuperCollection.java	(revision 4932)
@@ -0,0 +1,100 @@
+/**
+ *#########################################################################
+ *
+ * A component of the Gatherer application, part of the Greenstone digital
+ * library suite from the New Zealand Digital Library Project at the
+ * University of Waikato, New Zealand.
+ *
+ * Author: John Thompson, Greenstone Digital Library, University of Waikato
+ *
+ * Copyright (C) 1999 New Zealand Digital Library Project
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+* This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *########################################################################
+ */
+package org.greenstone.gatherer.cdm;
+/**************************************************************************************
+ * Written:     02/07/03
+ * Revised:     
+ **************************************************************************************/
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
+import org.greenstone.gatherer.cdm.DOMProxyListEntry;
+import org.w3c.dom.Element;
+
+public class SuperCollection
+    implements DOMProxyListEntry {
+
+    private Element element;
+    private String name;
+
+    public SuperCollection() {
+	element = null;
+	name = null;
+    }
+
+    public SuperCollection(Element element) {
+	this.element = element;
+	name = null;
+    }
+
+    public int compareTo(Object other) {
+	return this.getName().compareTo(other.toString());
+    }
+
+    public DOMProxyListEntry create(Element element) {
+	return new SuperCollection(element);
+    } 
+
+    public boolean equals(Object other) {
+	return (compareTo(other) == 0);
+    }
+
+    public Element getElement() {
+	return element;
+    }
+
+    public String getName() {
+	if(name == null && element != null) {
+	    name = element.getAttribute(CollectionConfiguration.NAME_ATTRIBUTE);
+	}
+	return name;
+    }
+
+    public boolean isAssigned() {
+	return (element != null && element.getAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE).equals(CollectionConfiguration.TRUE_STR));
+    }
+
+    public void setAssigned(boolean assigned) {
+	if(element != null) {
+	    element.setAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE, (assigned ? CollectionConfiguration.TRUE_STR : CollectionConfiguration.FALSE_STR));
+	}
+    }
+
+    public void setElement(Element element) {
+	this.element = element;
+	name = null;
+    }
+
+    public void setName(String name) {
+	this.name = name;
+	if(element != null) {
+	    element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, name);
+	}
+    }
+
+    public String toString() {
+	return getName();
+    }
+}
